{
  inputs = {
    nixpkgs.url = "github:nixos/nixpkgs/nixos-unstable";
  };

  outputs = { self, nixpkgs, ... } @ inputs:
    let
      pkgs = nixpkgs.legacyPackages.x86_64-linux;
    in
    {
      devShells.x86_64-linux.default = pkgs.mkShell {
        buildInputs = [
          (pkgs.lua5_1.withPackages (ps: with ps; [
            ({ fetchFromGitHub, fetchurl }:
              ps.buildLuarocksPackage {
                pname = "cmark";
                version = "0.30.2-1";
                knownRockspec = (fetchurl {
                  url = "mirror://luarocks/cmark-0.30.2-1.rockspec";
                  sha256 = "077kvl9xa9yj0fxyyxxw43k9v9dgd5f11ax8hhxj3nx8vfs5rps8";
                }).outPath;

                src = fetchFromGitHub {
                  owner = "jgm";
                  repo = "cmark-lua";
                  rev = "0.30.2";
                  hash = "sha256-6Bzq0FdyqXXiL6pLDRFbULFJpowF0P6CvAw8iqFXkkQ=";
                };
              })
            luafilesystem
            luasocket
            luasec
            fennel
          ]))
        ];
      };
    };
}
